#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform mat4 ProjMat;
uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform vec4 Pink;

in vec4 vertexColor;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    color *= vertexColor * ColorModulator;
    float fragmentDistance = -ProjMat[3].z / ((gl_FragCoord.z) * -2.0 + 1.0 - ProjMat[2].z);

    float nuts = 0.0;

    /* this is an excuse for me to play around with shaders but i guess it also looks kinda cool */

    if (fragmentDistance > 10) {
        nuts = 1.0;
    } else {
        nuts = fragmentDistance / 10;
    }

    nuts /= 3;
    nuts += 0.25;

    color.rgb = mix(color.rgb, Pink.rgb, nuts);
    fragColor = linear_fog(color, fragmentDistance, FogStart, FogEnd, FogColor);
}
